ideal
p386n
model flat, stdcall

NOWINERROR	= 1
NODDE		= 1
NOMMSYSTEM	= 1
NOWINSPOOL	= 1
include "windows.inc"
include "..\unit\xmplayer.ash"

udataseg

hInstance	dd ?
hTimer		dd ?
hEndEvent	dd ?
NAMESSIZE	= 4096
pCurrentName	dd ?
DirNameLength	dd ?
szFileNames	db NAMESSIZE dup (?)
szFileName	db 2*MAX_PATH dup (?)
szFilter	db 40 dup (?)
szError 	db 40 dup (?)
szErrorText	db 40 dup (?)

dataseg

szDefExt	db 'XM', 0, 0
OpenFileStruct	OPENFILENAME <19*4, 0, 0, O szFilter, 0, 0, 0,\
			      O szFileNames, NAMESSIZE, 0, 0, 0, 0,\
			      OFN_EXPLORER + OFN_FILEMUSTEXIST +\
			      OFN_HIDEREADONLY + OFN_ALLOWMULTISELECT,\
			      0, 0, O szDefExt, 0, 0, 0>
Freq		dd 44100
Flags		dd xmfStereo + xmf16bit + xmfHiPriority
VolScale	dd 4
AndMask 	db not xmf16bit, not xmf16bit, not xmfLongBuffer, not xmfLongBuffer
OrMask		db 0, xmf16bit, 0, xmfLongBuffer
szSongName	db 21 dup (0)

codeseg

;-----------------------------------------------------------------------------
;	Program entry point
;-----------------------------------------------------------------------------

proc	main
		; Get handle of instance
			xor	edi, edi
			call	GetModuleHandle, edi
			mov	[hInstance], eax
			mov	ebx, eax

		; Prepare initial data
			mov	[dword szFileName], edi
			call	LoadString, ebx, edi, O szError, 40
			call	LoadString, ebx, 100, O szFilter, 40
			xchg	eax, edi
			mov	edi, O szFilter
			mov	ecx, 40
		  repnz scasb
			mov	[dword edi], 'MX.*'
			mov	[edi+4], eax
			xchg	eax, edi

		; Initialize
			call	InitCommonControls
			call	InitPlayer
			call	CreateEvent, edi, edi, edi, edi
			mov	[hEndEvent], eax

		; Main window
			call	DialogBoxParam, ebx, 102,edi,O MainDlgProc,edi

		; Exit
			call	UnloadSong
			call	CloseHandle, [hEndEvent]
			call	ExitProcess, edi
endp

;-----------------------------------------------------------------------------
;	LoadNewSong(hwnd) - loads a module and starts it
;-----------------------------------------------------------------------------

align
proc	LoadNewSong hwnd
		; Clear names if needed
			cmp	[DirNameLength], 0
			jz	_lnmDontClearName
			mov	[byte szFileNames], 0

		; Open dialog
_lnmDontClearName:	mov	eax, [hwnd]
			mov	[OpenFileStruct.hwndOwner], eax
			call	GetOpenFileName, O OpenFileStruct
			or	eax, eax
			jz	_lnmErrorExit

		; Get directory name
			mov	edi, O szFileNames
			mov	ecx, -1
			mov	al, 0
			xor	eax, eax
		  repnz scasb
			not	ecx
			lea	eax, [ecx-1]
			cmp	[byte edi], 0
			jnz	_lnmManyFiles
			mov	eax, 0
_lnmManyFiles:		mov	[DirNameLength], eax
			mov	esi, O szFileNames
			mov	edi, O szFileName
			rep	movsb
			mov	[pCurrentName], esi

		; Load song and return
			call	LoadNextSong, [hwnd]
			ret
_lnmErrorExit:		stc
			ret
endp

;-----------------------------------------------------------------------------
;	LoadNextSong(hwnd) - load next selected module
;-----------------------------------------------------------------------------

align
proc	LoadNextSong hwnd
		; Copy file name
			mov	ebx, [pCurrentName]
_lnmNextModule: 	mov	edi, [DirNameLength]
			test	edi, edi
			jz	_lnmSingleFile
			add	edi, O szFileName + 1
			mov	[byte edi-1], '\'
			mov	esi, [pCurrentName]
_lnmNextChar:		lodsb
			stosb
			cmp	al, 0
			jnz	_lnmNextChar

		; Save pointer to next filename
			cmp	[byte esi], 0
			jnz	_lnmNotLastInBuf
			mov	esi, [DirNameLength]
			add	esi, O szFileNames
			inc	esi
_lnmNotLastInBuf:	mov	[pCurrentName], esi

		; Load and play
_lnmSingleFile: 	call	LoadSong, O szFileName, O szSongName, [hwnd],\
					  [Freq], [Flags], [VolScale]
			or	eax, eax
			jnz	_lnmDisplayError
			call	SetDlgItemText, [hwnd], 104, O szSongName
			mov	eax, [hEndEvent]
			cmp	[DirNameLength], 0
			jnz	_lnmMultipleFiles
			xor	eax, eax
_lnmMultipleFiles:	call	PlaySong, eax
			add	eax, 100
			cmp	eax, 100
			ja	_lnmDisplayError

		; Exit (OK)
			clc
			ret

		; Exit (Error)
_lnmDisplayError:	call	LoadString, [hInstance], eax, O szErrorText,40
			call	MessageBox, [hwnd], O szErrorText,\
					    O szError, MB_ICONEXCLAMATION
			cmp	[pCurrentName], ebx
			jnz	_lnmNextModule
			stc
			ret
endp

;-----------------------------------------------------------------------------
;	MainDlgProc(hwnd,uMsg,wParam,lParam) - main dialog callback
;-----------------------------------------------------------------------------

procdesc MainDlgProc DLGPROC

align
proc	MainDlgProc uses ebx esi edi, hwnd, uMsg, wParam, lParam
		; Dispatch message
			mov	ebx, [hwnd]
			mov	eax, [uMsg]
			cmp	eax, WM_TIMER
			jz	_mdTimer
			cmp	eax, WM_COMMAND
			jz	_mdCommand
			cmp	eax, WM_INITDIALOG
			jnz	_sdQuit

		; WM_INITDIALOG
			call	SetTimer, ebx, 0, 55, 0
			mov	[hTimer], eax
			jmp	_mdSetup

		; WM_TIMER
_mdTimer:		call	GetSyncEventState
			cmp	eax, -1
			jz	_mdNoSync
			call	SetDlgItemInt, ebx, 103, eax, 0
_mdNoSync:
			call	GetSongPosition
			movsx	ecx, ax
			sar	eax, 16
			push	ecx
			call	SetDlgItemInt, ebx, 101, eax, 1
			pop	ecx
			call	SetDlgItemInt, ebx, 102, ecx, 1

			call	WaitForSingleObject, [hEndEvent], 0
			cmp	eax, WAIT_OBJECT_0
			jnz	_sdOK
			call	LoadNextSong, [hwnd]
			jmp	_sdOK

		; WM_COMMAND
_mdCommand:		movzx	eax, [word wParam]
			cmp	eax, 105
			jz	_mdReload
			cmp	eax, 106
			jz	_mdSetup
			cmp	eax, 107
			jnz	_sdQuit

		; EndDialog
			call	KillTimer, [hwnd], [hTimer]
			jmp	_sdEndDialog

		; Setup (and reload)
_mdSetup:		call	DialogBoxParam, [hInstance], 101, [hwnd],\
						O SetupDlgProc, 0

		; Reload module
_mdReload:		call	LoadNewSong, [hwnd]
			jmp	_sdOK
endp

;-----------------------------------------------------------------------------
;	SetupDlgProc(hwnd,uMsg,wParam,lParam) - setup dialog callback
;-----------------------------------------------------------------------------

procdesc SetupDlgProc DLGPROC

align
proc	SetupDlgProc uses ebx esi edi, hwnd, uMsg, wParam, lParam
		; Dispatch message
			mov	ebx, [hwnd]
			mov	eax, [uMsg]
			cmp	eax, WM_HSCROLL
			jz	_sdHScroll
			cmp	eax, WM_COMMAND
			jz	_sdCommand
			cmp	eax, WM_INITDIALOG
			jz	_sdInitDialog
_sdQuit:		xor	eax, eax
			ret

		; WM_INITDIALOG
_sdInitDialog:		mov	eax, 102
			cmp	[Freq], 22050
			ja	_sdIncFreq
			sbb	eax, 0
			jmp	_sdUpdateFreq
_sdIncFreq:		inc	eax
_sdUpdateFreq:		call	CheckDlgButton, ebx, eax, BST_CHECKED
			mov	eax, 104
			bt	[Flags], 1 ; xmf16bit
			adc	eax, 0
			call	CheckDlgButton, ebx, eax, BST_CHECKED
			mov	eax, 106
			bt	[Flags], 2 ; xmfLongBuffer
			adc	eax, 0
			call	CheckDlgButton, ebx, eax, BST_CHECKED
			test	[byte Flags], xmfUseMMX
			jz	_sdNoMMX
			call	CheckDlgButton, ebx, 108, BST_CHECKED
_sdNoMMX:		test	[byte Flags], xmfStereo
			jz	_sdNoStereo
			call	CheckDlgButton, ebx, 109, BST_CHECKED
_sdNoStereo:		call	SendDlgItemMessage, ebx, 110, TBM_SETPOS, 1,\
						    [VolScale]
			call	SendDlgItemMessage, ebx, 110, TBM_SETRANGE, 1,\
						    1+(32 shl 16)
			call	SendDlgItemMessage, ebx, 110, TBM_SETTICFREQ,\
						    4, 0
			jmp	_sdSetVolScale

		; WM_HSCROLL
_sdHScroll:		call	SendDlgItemMessage, ebx, 110, TBM_GETPOS, 0, 0
			mov	[VolScale], eax
_sdSetVolScale: 	call	SetDlgItemInt, ebx, 111, [VolScale], 0
_sdOK:			mov	eax, 1
			ret

		; WM_COMMAND
_sdCommand:		movzx	esi, [word wParam]
			cmp	esi, 112
			jz	_sdEndDialog
			cmp	esi, 110
			jnc	_sdQuit
			call	IsDlgButtonChecked, ebx, esi
			cmp	esi, 108
			jz	_sdMMX
			cmp	esi, 109
			jz	_sdStereo
			or	eax, eax
			jz	_sdOK
			cmp	esi, 104
			jnc	_sdRadios
			mov	ecx, esi
			sub	cl, 101
			mov	eax, 11025
			shl	eax, cl
			mov	[Freq], eax
			jmp	_sdOK
_sdMMX: 		and	[byte Flags], not xmfUseMMX
			or	eax, eax
			jz	_sdOK
			or	[byte Flags], xmfUseMMX
			jmp	_sdOK
_sdStereo:		and	[byte Flags], not xmfStereo
			or	eax, eax
			jz	_sdOK
			or	[byte Flags], xmfStereo
			jmp	_sdOK
_sdRadios:		sub	esi, 104
			mov	al, [AndMask+esi]
			and	[byte Flags], al
			mov	al, [OrMask+esi]
			or	[byte Flags], al
			jmp	_sdOK

		; EndDialog
_sdEndDialog:		call	EndDialog, [hwnd], 0
			jmp	_sdOK
endp

end main