struc	CHANNEL
	SampleAddr	dd ?
	InstrAddr	dd ?
	Finetune	dd ?
	DeltaTune	dd ?
	VibTune 	dd ?
	FadeoutVol	dd ?
	SampleBuf	dd ?
	SamplePos	dd ?
	LeftVolume	dd ?
	RightVolume	dd ?
	IntStep 	dd ?
	FracStep	dd ?
	FracPos 	dd ?
	ndPattern	dd ?

	VolEnvPos	dw ?
	PanEnvPos	dw ?
	Effect1 	dw ?
	Effect2 	dw ?

	Instr		db ?
	Note		db ?
	Volume		db ?
	VolEnvVol	db ?
	DeltaVol	db ?
	Panning 	db ?
	PanEnvPan	db ?
	VibPos		db ?
	FadeinVib	db ?
	VibSweepCount	db ?
	VibSweepPos	db ?
	Flags		db ?

	ArpPos		db ?
	Porta		db 3 dup (?)
	Vib		db ?
	VibEPos 	db ?
	VibEWave	db ?
	Tremolo 	db ?
	TremEPos	db ?
	TremEWave	db ?
	SampleOffs	db ?
	VolSlide	db ?
	FinePortaUp	db ?
	FinePortaDown	db ?
	ExFinePortaUp	db ?
	ExFinePortaDown db ?
	ndCount 	db ?

	_Align		db 3 dup (?)
ends

struc	SAMPLE
	Flags		db ?
	Volume		db ?
	Panning 	db ?
	_Align		db ?
	Finetune	dd ?
	LoopLength	dd ?
	LoopEnd 	dd ?
	SampleBuf	dd ?
ends

struc	INSTRUMENT
	Flags		db ?
	VolBegin	dw ?
	VolEndP1	dw ?
	VolSustain	dw ?
	VolEnvBorder	dw ?
	VolEnv		db 325 dup (?)
	PanBegin	dw ?
	PanEndP1	dw ?
	PanSustain	dw ?
	PanEnvBorder	dw ?
	PanEnv		db 325 dup (?)
	VibDepth	db ?
	VibSpeed	db ?
	VibSweep	db ?
	Fadeout 	dd ?
	VibWaveAddr	dd ?
	Samples 	db 96 dup (?)
ends

flagNotLoaded	= 01h				; Global flags
flagLoopModule	= 02h
flagPlaying	= 04h
flagMix16	= 08h
flagStereo	= 10h
flagUseMMX	= 20h
flagBreak	= 40h
flagHiPriority	= 80h

flag2StopModule = 01h				; Global flags 2
flag2Stopping	= 02h

lflagStereo	= 01h				; Load flags
lflagMix16	= 02h
lflag1Second	= 04h
lflagUseMMX	= 08h
lflagHiPriority = 10h
lflagExternalLoad = 20h
lflagLocalSound = 40h

pflagNote	= 01h				; XM pattern data flags
pflagInstr	= 02h
pflagVolume	= 04h
pflagEffType	= 08h
pflagEffData	= 10h

flagResetNote	= 01h				; Pattern flags
flagResetSample = 02h
flagResetVolume = 04h
flagResetEffect1 = 08h
flagResetEffect2 = 10h

flagSample	= 01h				; Channel flags
flagEndSample	= 02h
flagEff1On	= 04h
flagEff2On	= 08h
flagEndNote	= 10h

flagLoop	= 01h				; Sample flags
flag16bit	= 02h

flagVolEnvelope = 01h				; Instrument flags
flagPanEnvelope = 02h

MAXNOTE 	= 120	; 78 -> 48kHz; 90 -> 100kHz

ERROR_FILEOPEN	= 1
ERROR_FILESIZE	= 2
ERROR_FILEREAD	= 3
ERROR_MEMORY	= 4
ERROR_MODULE	= 5
ERROR_SOUND	= 6
ERROR_EVENT	= 7
ERROR_NOTIFY	= 8

procdesc InitPlayer
procdesc LoadSong :dword, :dword, :dword, :dword, :dword, :dword
procdesc PlaySong :dword
procdesc GetSongPosition
procdesc GetSyncEventState
procdesc StopSong
procdesc UnloadSong

; To allow C linkage
_GetFileSize		equ <GetFileSize>
_WaitForMultipleObjects equ <WaitForMultipleObjects>
_CreateEvent		equ <CreateEventA>
_CreateFile		equ <CreateFileA>
_CreateThread		equ <CreateThread>
_ReadFile		equ <ReadFile>
_GlobalFree		equ <GlobalFree>
_GlobalAlloc		equ <GlobalAlloc>
_TerminateThread	equ <TerminateThread>
_CloseHandle		equ <CloseHandle>
_SetEvent		equ <SetEvent>
_DirectSoundCreate	equ <DirectSoundCreate>
_SetThreadPriority	equ <SetThreadPriority>
_InitializeCriticalSection equ <InitializeCriticalSection>
_DeleteCriticalSection	equ <DeleteCriticalSection>
_EnterCriticalSection	equ <EnterCriticalSection>
_LeaveCriticalSection	equ <LeaveCriticalSection>

ifdef XMC
; C libraries have declared function names in C style.
extrn _GetFileSize@8			:proc
extrn _WaitForMultipleObjects@16	:proc
extrn _CreateEventA@16			:proc
extrn _CreateFileA@28			:proc
extrn _CreateThread@24			:proc
extrn _ReadFile@20			:proc
extrn _GlobalFree@4			:proc
extrn _GlobalAlloc@8			:proc
extrn _TerminateThread@8		:proc
extrn _CloseHandle@4			:proc
extrn _SetEvent@4			:proc
extrn _DirectSoundCreate@12		:proc
extrn _SetThreadPriority@8		:proc
extrn _InitializeCriticalSection@4	:proc
extrn _DeleteCriticalSection@4		:proc
extrn _EnterCriticalSection@4		:proc
extrn _LeaveCriticalSection@4		:proc

_GetFileSize		equ <_GetFileSize@8>
_WaitForMultipleObjects equ <_WaitForMultipleObjects@16>
_CreateEvent		equ <_CreateEventA@16>
_CreateFile		equ <_CreateFileA@28>
_CreateThread		equ <_CreateThread@24>
_ReadFile		equ <_ReadFile@20>
_GlobalFree		equ <_GlobalFree@4>
_GlobalAlloc		equ <_GlobalAlloc@8>
_TerminateThread	equ <_TerminateThread@8>
_CloseHandle		equ <_CloseHandle@4>
_SetEvent		equ <_SetEvent@4>
_DirectSoundCreate	equ <_DirectSoundCreate@12>
_SetThreadPriority	equ <_SetThreadPriority@8>
_InitializeCriticalSection equ <_InitializeCriticalSection@4>
_DeleteCriticalSection	equ <_DeleteCriticalSection@4>
_EnterCriticalSection	equ <_EnterCriticalSection@4>
_LeaveCriticalSection	equ <_LeaveCriticalSection@4>

endif;def XMC
